sourceDir <- function(path, trace = TRUE, ...) {
   for (nm in list.files(path, pattern = "\\.[RrSsQq]$")) {
      if(trace) cat(nm,":")           
      source(file.path(path, nm), ...)
      if(trace) cat("\n")
   }
}

sourceDir("../R")




# First order CFA of the Lienert-LSD data
# Variables A, B and C
# Type in the observed frequencies
ofreq<-c(20,1,4,12,3,10,15,0)

# Type in the configurations in CFA Format)
# c stands for concatenate
config<-matrix(c(1,1,1,1,1,2,1,2,1,1,2,2,2,1,1,2,1,2,2,2,1,2,2,2),ncol=3,byrow=TRUE)


##### use configuration patterns as input; original R-package 'cfa' 
# Run the cfa package and put everything into the object called mode
mode<-cfa(config,ofreq,exact.binom.test=TRUE, sorton="label",sort.descending=FALSE,alpha=0.05)
mode

##### R-package by Xianming 'cfa_new'; here design matrix with three main effects A, B and C
##### Errors/problems: in the column 'label' the printout lists the design matrix not the configurations
##### Errors/problems: the observed frequencies are not listed in the correct order
####
X<-matrix(c(1,1,1,1,1,1,1,1, 1,1,1,1,-1,-1,-1,-1, 1,1,-1,-1,1,1,-1,-1,   1,-1,1,-1,1,-1,1, -1),ncol=4) 
mode_<-cfa_new(X,conf_cols=2:4,ofreq,binom.test=TRUE, sorton="label",sort.descending=FALSE,alpha=0.05)
mode_

##### R-package by Xianming; here design matrix with saturated model
##### Errors/problems: same here, the program runs well but the design matrix is listed instead of 
##### the configurations
X<-matrix(c(1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,1,1,-1,-1,1,1,-1,-1,1,-1,1,-1,1,-1,1,-1,1,1,-1,-1,-1,-1,-1,-1,1,-1,1,-1,-1,1,-1,1,1,-1,- 1,1,1,-1,-1,1,1,-1,-1,1,-1,1,1,-1),ncol=8) 
mode8<-cfa_new(X,conf_cols=2:4,ofreq,binom.test=TRUE, sorton="label",sort.descending=FALSE,alpha=0.05)
mode8

###### R-package by Xianming; design matrix with three main effects and two  interactions A x B, A x C
###### Errors/problems: see above; although the correct expected freqeuncies are listed
X<-matrix(c(1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,1,1,-1,-1,1,1,-1,-1,1,-1,1,-1,1,-1,1,-1,1,1,-1,-1,-1,-1,-1,-1,1,-1,1,-1,-1,1,-1,1),ncol=6) 
mode7<-cfa_new(X,conf_cols=2:4,ofreq,binom.test=TRUE, sorton="label",sort.descending=FALSE,alpha=0.05)
mode7

#######R-package by Xianming; here design matrix with null model or CCA
###### Errors/problems: runs well; the overall pearson chi-sqaure is correct; same output problsm as above
X<-matrix(c(1,1,1,1,1,1,1,1),ncol=1)
mode5<-cfa_new(X,conf_cols=2:4,ofreq, binom.test=TRUE, exact.binom.test = TRUE, exact.binom.limit = 21, sorton="label",sort.descending=TRUE,alpha=0.05)
mode5



###### another example from the book: the example you have sent to me two main effects A, B  # 
X1<-matrix(c(1,1,1,1, -1, -1, 1, 1, -1, 1,-1,1),ncol=3)
ofreq1 <-c(5, 37, 8, 6)
mode6<-cfa_new(X1,conf_cols=2:4,ofreq1,binom.test=TRUE, sorton="label",sort.descending=TRUE,alpha=0.05)
mode6


###### Exercise(PartII): four variables D,I,R,V
X2<-matrix(c(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1, 1,1,1,1,-1,-1,-1,-1,1,1,1,1,-1,-1,-1,-1, 1,1,-1,-1,1,1,-1,-1,1,1,-1,-1,1,1,-1,-1, 1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1 ),ncol=5)
ofreq2 <-c(15,30,9,32,23,22,14,16,25,22,46,27,14,8,47,12)
mode66<-cfa_new(X2,conf_cols=2:5,ofreq2,binom.test=TRUE, sorton="label",sort.descending=TRUE,bonferroni=FALSE,alpha=0.05)
mode66




####
# end of code
####